/*
 ===========================================================================
 SamyConsole 2.1 by geo650, 2010-08...10
 
 
 
 30.10.2011 change by Denny :
 
 Suport for Genoa TV...
 Added InFly patch for Keyboard in libSDL.so
 Added Keyboard handling done by Aquardian 

 Tested on :
 UE55D8000 T-GAP8DEUC
 UE32D6510 T-GASDEUC
 
 
 ===========================================================================
*/

// enabled for testing purposes - to create i686 exe binary


#define SCREEN_WIDTH	(1920/2)
#define SCREEN_HEIGHT	(1080/2)
#define SCREEN_BPP	32
#define SC_UPBITMAP	"sc_up.png"
#define SC_DOWNBITMAP	"sc_down.png"
#define FONTBITMAP	"fonts16x16.png"
#define CHARWIDTH	12	
#define CHARHEIGHT	16
#define CHARSHIFT	2
#define LINEHEIGHT	18	
#define MAX_X		80
#define MAX_Y		30
#define CONSOLE_COLUMNS	80
#define CONSOLE_LINES	24
#define CONSOLE_SHIFT	2

#define DELAY_THREAD	100

#define DEFAULT_PORT 23
#define MAXDATASIZE	512
#define MAX_CBUFLEN	2000
#define DEFAULT_HOST	"192.168.0.1"

typedef unsigned char BYTE;

#define	xEOF	(BYTE)236
#define	SUSP	(BYTE)237
#define	ABORT	(BYTE)238
#define EOR     (BYTE)239      	
#define	SE	(BYTE)240
#define	NOP	(BYTE)241	
#define	DM	(BYTE)242	

#define	BREAK	(BYTE)243	
#define	IP	(BYTE)244	
#define	AO	(BYTE)245	
#define	AYT	(BYTE)246	
#define	EC	(BYTE)247
#define	EL	(BYTE)248	
#define	GA	(BYTE)249
#define	SB	(BYTE)250	
#define	WILL	(BYTE)251	
#define	WONT	(BYTE)252	
#define	DO	(BYTE)253
#define	DONT	(BYTE)254	
#define	IAC	(BYTE)255	

#define BELL	7
#define BACKSPC	8
#define LF	10
#define CR	13
#define SI	15
#define ESC	27


#define TELOPT_BINARY		(BYTE)0		
#define TELOPT_ECHO		(BYTE)1		
#define	TELOPT_RCP		(BYTE)2		
#define	TELOPT_SGA		(BYTE)3		
#define	TELOPT_NAMS		(BYTE)4
#define	TELOPT_STATUS		(BYTE)5		
#define	TELOPT_TM		(BYTE)6		
#define	TELOPT_RCTE		(BYTE)7
#define TELOPT_NAOL		(BYTE)8	
#define TELOPT_NAOP		(BYTE)9		
#define TELOPT_NAOCRD		(BYTE)10
#define TELOPT_NAOHTS		(BYTE)11	
#define TELOPT_NAOHTD		(BYTE)12	
#define TELOPT_NAOFFD		(BYTE)13	
#define TELOPT_NAOVTS		(BYTE)14
#define TELOPT_NAOVTD		(BYTE)15	
#define TELOPT_NAOLFD		(BYTE)16	
#define TELOPT_XASCII		(BYTE)17	
#define	TELOPT_LOGOUT		(BYTE)18	
#define	TELOPT_BM		(BYTE)19	
#define	TELOPT_DET		(BYTE)20
#define	TELOPT_SUPDUP		(BYTE)21	
#define	TELOPT_SUPDUPOUTPUT	(BYTE)22	
#define	TELOPT_SNDLOC		(BYTE)23	
#define	TELOPT_TTYPE		(BYTE)24	
#define	TELOPT_EOR		(BYTE)25	
#define	TELOPT_TUID		(BYTE)26	
#define	TELOPT_OUTMRK		(BYTE)27
#define	TELOPT_TTYLOC		(BYTE)28	
#define	TELOPT_3270REGIME	(BYTE)29	
#define	TELOPT_X3PAD		(BYTE)30
#define	TELOPT_NAWS		(BYTE)31	
#define	TELOPT_TSPEED		(BYTE)32
#define	TELOPT_LFLOW		(BYTE)33	
#define TELOPT_LINEMODE		(BYTE)34	
#define TELOPT_XDISPLOC		(BYTE)35
#define TELOPT_ENVIRON		(BYTE)36
#define	TELOPT_AUTHENTICATION	(BYTE)37
#define	TELOPT_ENCRYPT		(BYTE)38
#define TELOPT_NEW_ENVIRON	(BYTE)39
#define	TELOPT_EXOPL		(BYTE)255

#define MAX_TTYP     64	
#define DEF_TTYP     "VT100"
#define MAX_HOSTLEN  255

#include <sys/mman.h>
#include <pthread.h>
#include <netdb.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


FILE *log_fp;


char *ESCSEQ = "\033[";	
char host[MAX_HOSTLEN+1];
int hostlen;
int port;
char ttyp[MAX_TTYP];
char buffer[MAXDATASIZE+1];
int buffer_len;
char cbuf[MAX_CBUFLEN];
int cbuf_write;
int cbuf_read;
int cbuf_len;
SDL_Surface *screen;
SDL_VideoInfo *videoinfo;
#define TEXT_APLHA	128
Uint32 screen_color, cursor_color, margin_color;
SDL_Rect fontrect, dstrect;
SDL_Surface *fonts, *sc_up, *sc_down;
typedef struct { int x; int y; } curpos;
curpos cur, ANSI_saved_cur, tmp_cur;
int cursor_visible;
int entering_adr;
char tabstops[CONSOLE_COLUMNS];	
char console_buffer[CONSOLE_COLUMNS * CONSOLE_LINES + 1];
Uint8 *kbhits;		
pthread_t ID_thread;	
int monitoring;		
int stop_monitoring;

void mcas_debug(const char *format, ...)
{
	char String_p[1024] = "";
	FILE * logfile;
	va_list	arguments;
	#if defined (ARM7)
	logfile = fopen("/dev/kmsg", "a+");
	#else
	//logfile = fopen("/mnt/hgfs/samlinux/module_game_game.txt", "a+");
	#endif
	va_start(arguments, format);
	vsprintf(String_p, format, arguments);
	va_end(arguments);

	#if defined (ARM7)
	if (logfile)
		fprintf(logfile, "%s", String_p );
	fclose(logfile);
	#else
	printf("%s", String_p);
	#endif
}



#ifndef EXE

int ex_key_code = 0;
int ex_key_mod  = 0;
void send_key_event(int, int);
void send_key_event(int key_code, int key_mod)
{
    SDL_Event uevent;
    int hitval;
    if (key_code == 0) return;
    if (key_code > 0)
    {
	uevent.key.type = SDL_KEYDOWN;
	uevent.key.state = SDL_PRESSED;
	hitval = 1;
    }
    else
    {
	uevent.key.type = SDL_KEYUP;
	uevent.key.state = SDL_RELEASED;
	key_code = -key_code;
	hitval = 0;
    }
    uevent.key.keysym.sym = key_code;
    uevent.key.keysym.mod = key_mod;
    uevent.key.keysym.unicode = 0;
    uevent.key.keysym.scancode = 0;
    SDL_PushEvent(&uevent);
    if (kbhits)
    {
	kbhits[key_code] = hitval;
	if (key_mod) kbhits[key_mod] = hitval;
    }
}

#define AUTOREPEAT_DELAY 10	
#define AUTOREPEAT_LOOPS 20	
int repeat_counter = 0;
int last_key_code = 0;
void remote_key_event_sender(void)
{
	if (ex_key_code < 0)	
	{
		send_key_event(ex_key_code, ex_key_mod);
		ex_key_code = 0;
		ex_key_mod  = 0;
		repeat_counter = 0;
	}
	else if (ex_key_code > 0)	
	{
		if (last_key_code == ex_key_code) { SDL_Delay(AUTOREPEAT_DELAY); repeat_counter++; } else repeat_counter=0;
		if ((repeat_counter == 0) || (repeat_counter > AUTOREPEAT_LOOPS)) send_key_event(ex_key_code, ex_key_mod);
		last_key_code = ex_key_code;
	}
}

#endif

void console_textout(int x, int y, char *text, int flip, int erase_bkg, int dim)
{
   int i, ln, ch;
   ln = strlen(text);
   if (ln < 1) return; 
   SDL_SetAlpha(fonts, SDL_SRCALPHA, dim?TEXT_APLHA:255);	
   SDL_SetColorKey(fonts, erase_bkg?0:SDL_SRCCOLORKEY, screen_color);
   dstrect.w = CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   for (i=0; i<ln; i++)
   {
       ch = *(text++);
       dstrect.x = (x++) * CHARWIDTH;
       dstrect.y = y * LINEHEIGHT;
       if (erase_bkg) SDL_FillRect(screen, &dstrect, screen_color);
       fontrect.y = 16 * (ch >> 4);
       fontrect.x = 16 * (ch - 16 * (ch >> 4)) + CHARSHIFT;
       SDL_BlitSurface(fonts, &fontrect, screen, &dstrect);
       if (x >= MAX_X) { x=0; y++; if (y >= MAX_Y) y=0; }
   }
   if (flip) SDL_Flip(screen);
}

void draw_cursor(int flip)
{
   char s[8];
   if (cursor_visible) return; 
   if (cur.x >= CONSOLE_COLUMNS) return; 
   if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES) return; 
   dstrect.x = cur.x * CHARWIDTH;
   dstrect.y = cur.y * LINEHEIGHT + CHARHEIGHT;
   dstrect.w = CHARWIDTH - 2;
   dstrect.h = 2;
   SDL_FillRect(screen, &dstrect, cursor_color);
   cursor_visible = 1;
   sprintf(s, "{%02d,%02d}", cur.x+1, cur.y+1 - CONSOLE_SHIFT);
   console_textout(72,26, s, flip, 1, 0);
}

void hide_cursor()
{
   if (cursor_visible)
   {
      if (cur.x >= CONSOLE_COLUMNS) return; 
      if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES) return; 
      if (cur.y < CONSOLE_SHIFT) return; 
      dstrect.x = cur.x * CHARWIDTH;
      dstrect.y = cur.y * LINEHEIGHT + CHARHEIGHT;
      dstrect.w = CHARWIDTH - 2;
      dstrect.h = 2;
      SDL_FillRect(screen, &dstrect, screen_color);
      cursor_visible = 0;
   }
}

void scroll_screen_up()
{
   SDL_LockSurface(screen);
   memcpy(screen->pixels + CONSOLE_COLUMNS * CHARWIDTH * CONSOLE_SHIFT * LINEHEIGHT * (SCREEN_BPP / 8),
          screen->pixels + CONSOLE_COLUMNS * CHARWIDTH * (CONSOLE_SHIFT + 1) * LINEHEIGHT * (SCREEN_BPP / 8),
          CONSOLE_COLUMNS * CHARWIDTH * (CONSOLE_LINES - 1) * LINEHEIGHT * (SCREEN_BPP / 8));
   dstrect.x = 0;
   dstrect.y = (CONSOLE_SHIFT + CONSOLE_LINES - 1) * LINEHEIGHT;
   dstrect.w = CONSOLE_COLUMNS * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   SDL_FillRect(screen, &dstrect, screen_color);
   SDL_UnlockSurface(screen);
   memcpy(console_buffer, console_buffer + CONSOLE_COLUMNS, CONSOLE_COLUMNS * (CONSOLE_LINES-1));
   memset(console_buffer + CONSOLE_COLUMNS * (CONSOLE_LINES-1), ' ', CONSOLE_COLUMNS);
}

void scroll_screen_down(int from_line)
{
   int line;
   SDL_LockSurface(screen);
   for (line = CONSOLE_LINES-1; line > from_line+1; line--)
	memcpy(	screen->pixels + CONSOLE_COLUMNS * CHARWIDTH * line * LINEHEIGHT * (SCREEN_BPP / 8),
		screen->pixels + CONSOLE_COLUMNS * CHARWIDTH * (line-1) * LINEHEIGHT * (SCREEN_BPP / 8),
		CONSOLE_COLUMNS * CHARWIDTH * LINEHEIGHT * (SCREEN_BPP / 8));
   dstrect.x = 0;
   dstrect.y = (CONSOLE_SHIFT + from_line) * LINEHEIGHT;
   dstrect.w = CONSOLE_COLUMNS * CHARWIDTH;
   dstrect.h = CHARHEIGHT;
   SDL_FillRect(screen, &dstrect, screen_color);
   SDL_UnlockSurface(screen);
   for (line = CONSOLE_LINES-1; line > from_line+1; line--)
       memcpy(console_buffer + line * CONSOLE_COLUMNS, console_buffer + (line-1) * CONSOLE_COLUMNS, CONSOLE_COLUMNS);
   memset(console_buffer + from_line * CONSOLE_COLUMNS, ' ', CONSOLE_COLUMNS);
}

void console_char(char c, int flip)
{
   char s[2];
   if (c)
   {
      s[0] = c;
      s[1] = 0;
      console_textout(cur.x, cur.y, s, flip, 1, 1);
      console_buffer[cur.x + (cur.y - CONSOLE_SHIFT) * CONSOLE_COLUMNS] = c;
      cur.x++; if (cur.x >= CONSOLE_COLUMNS) { cur.x = 0; cur.y++; }
      if (cur.y >= CONSOLE_SHIFT + CONSOLE_LINES)	
      {
         scroll_screen_up();	
         
         cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1; 
      }

   }
}

void console_print(char *s)
{
   int ln, i;
   ln = strlen(s); if (ln < 1) return; 
   for (i = 0; i < ln; i++) console_char(s[i], 0);
   SDL_Flip(screen);
}

void cls(int from_line, int before_line)
{
   int i;
   char empty_line[CONSOLE_COLUMNS+1];
   memset(empty_line, ' ', CONSOLE_COLUMNS);
   empty_line[CONSOLE_COLUMNS] = 0;

   for (i = from_line; i < before_line; i++)
       console_textout(0, i + CONSOLE_SHIFT, empty_line, 0, 1, 1);
   cur.x = 0;
   cur.y = CONSOLE_SHIFT;
   SDL_Flip(screen);
}

void cls_to_cur()
{
   int i;
   char empty_line[CONSOLE_COLUMNS+1];
   memset(empty_line, ' ', CONSOLE_COLUMNS);
   empty_line[CONSOLE_COLUMNS] = 0;
   if (cur.y > CONSOLE_SHIFT)
      for (i = 0; i < cur.y - CONSOLE_SHIFT-1; i++)
	  console_textout(0, i + CONSOLE_SHIFT, empty_line, 0, 1, 1);
   empty_line[cur.x + 1] = 0;
   console_textout(0, cur.y, empty_line, 0, 1, 1);
   SDL_Flip(screen);
}

void new_line()
{
   if (cur.y < CONSOLE_SHIFT + CONSOLE_LINES - 1) cur.y++;
   else 
   {
      scroll_screen_up();	
      cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1; 
   }
   cur.x = 0;
}

void show_help()
{
   new_line();
   new_line();
   console_print("SamyConsole HELP:");
   new_line();
   console_print("- F1: help");
   new_line();
   console_print("- F2: connect to another server");
   new_line();
   console_print("- F10: exit");
   new_line();
   console_print("- F12: clear screen");
   new_line();
#ifndef EXE
   console_print("- REMOTE CONTROL: MENU=help, EXIT,RETURN,TV,CONTENT,POWER=exit,");
   new_line();
   console_print("                  TOOLS=clear screen, ENTER=enter");
   new_line();
#endif
   new_line();
}

int datasend(int *sockfd, char *buf, int bytes_to_send)
{
   int bytes_sent;

   if (bytes_to_send > 0)
   {
      if ((bytes_sent = send(*sockfd, buf, bytes_to_send, 0)) == -1) return 1; 
      if (bytes_sent != bytes_to_send) return 2; 
   }

   return 0; 
}

int send_IAC(int *sockfd, BYTE operation_type, BYTE option)
{
   char command[3];
   command[0] = IAC;
   command[1] = operation_type;
   command[2] = option;
   return datasend(sockfd, command, 3);
}

int send_SB_TTYPE(int *sockfd)
{
   char command[sizeof(ttyp)+6];
   int z=0;
   command[z++] = IAC;
   command[z++] = SB;
   command[z++] = TELOPT_TTYPE;
   command[z++] = 0;           
   strcpy(command+z, ttyp); z += strlen(ttyp);
   command[z++] = IAC;
   command[z++] = SE;
   return datasend(sockfd, command, z);
}

int send_SB_NAWS(int *sockfd)
{
   char command[9];
   int z=0;
   command[z++] = IAC;
   command[z++] = SB;
   command[z++] = TELOPT_NAWS;
   command[z++] = CONSOLE_COLUMNS >> 8;   
   command[z++] = CONSOLE_COLUMNS & 0xFF; 
   command[z++] = CONSOLE_LINES >> 8;     
   command[z++] = CONSOLE_LINES & 0xFF;   
   command[z++] = IAC;
   command[z++] = SE;
  
   return datasend(sockfd, command, z);
}

void clear_cbuffer()
{
   cbuf_len = 0;
   cbuf_write = 0;
   cbuf_read = 0;
}

int put_bytes_to_cbuf(char *buf, int num)
{
   int i;
   if (num <= 0) return 0; 
   if (num > MAX_CBUFLEN - cbuf_len) return 1; 

   for (i=0; i<num; i++)
   {
       cbuf[cbuf_write++] = *(buf++); 
       cbuf_len++; 
       if (cbuf_write >= MAX_CBUFLEN) cbuf_write=0; 
   }
   return 0;
}

int get_byte_from_cbuf(void)
{
   BYTE b;

   if (cbuf_len <= 0) return -1; 
   if (cbuf_read >= MAX_CBUFLEN) cbuf_read = 0; 
   b = cbuf[cbuf_read++];
   cbuf_len--;
#ifdef EXE
printf("{%d:%c}", b, (b>=32)?b:'.'); fflush(0);

#endif
   return b;
}

int get_prev_byte_from_cbuf(int back)
{
   BYTE b;
   int temp_read;
   if (back >= MAX_CBUFLEN) return -1;  
   temp_read = cbuf_read - back;
   if (temp_read < 0) temp_read += MAX_CBUFLEN; 
   b = cbuf[temp_read];
   return b;
}

int extract_params(char *buf, int buflen)
{
   char c;
   int i = 0;
   int k = 0;
   int x = 1;
   if (buflen < 1) return 0;
   while (buflen && ((c = get_prev_byte_from_cbuf(x++)) != '[')) buflen--;
   if (buflen <= 0) return 0; 
   x-=2;
   if (x < 1) return 0;
   for (i=x; i > 1; i--) buf[k++] = get_prev_byte_from_cbuf(i);
   buf[k] = 0;
   return k;
}

void backspace(int with_erase)
{
   cur.x--; if (cur.x < 0) { cur.x = CONSOLE_COLUMNS - 1; cur.y--; } 
   if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT; 
   if (with_erase)
   {
      console_textout(cur.x, cur.y, " ", 0, 1, 1); 
      console_buffer[cur.x + (cur.y - CONSOLE_SHIFT) * CONSOLE_COLUMNS] = ' '; 
   }
}

void reset_terminal()
{
   int i;
   cur.x = 0;
   cur.y = CONSOLE_SHIFT;
   ANSI_saved_cur = cur;
   for (i = 0; i < CONSOLE_COLUMNS; i++) tabstops[i] = 0;
}

int parse(int *sockfd)
{
   int i, ib, ioption, count;
   BYTE operation_type;
   char opbuf[80];
   if (cbuf_len <= 0) return 0;
   hide_cursor();
   while(cbuf_len)
   {
      ib = get_byte_from_cbuf();
      if (ib != -1)
      {
         switch(ib)
         {
            case IAC:
              if (cbuf_len >= 1) 
              {
                 ib = get_byte_from_cbuf();
                 if (ib == -1) return 1; else operation_type = ib;
                 if (operation_type == SE) ioption=-1; 
                 else
                 {
                    if (cbuf_len >= 1)               
                    {
                       ib = get_byte_from_cbuf();    
                       if (ib == -1) return 1; else ioption = ib;
                    }
                    else ioption = -1; 
                 }
                 switch(operation_type)
                 {                 
                    case DO:
                      switch(ioption)
                      {
                        case TELOPT_TTYPE:            
                             if (send_IAC(sockfd, WILL, ioption)) return 1;
                             break;
                        case TELOPT_NAWS:             
                             if (send_IAC(sockfd, WILL, ioption)) return 1;
                             if (send_SB_NAWS(sockfd)) return 1;
                             break;
                        default:                      
                             if (send_IAC(sockfd, WONT, ioption)) return 1;
                             break; 
                      } 
                      break;
                    case SB:
                      switch(ioption)
                      {
                        case TELOPT_TTYPE:                  
                             if (cbuf_len>=3)                      
                             {
                                ib = get_byte_from_cbuf();
                                if (ib != 1) return 1; 

                                ib = get_byte_from_cbuf();
                                if (ib != IAC) return 1; 

                                ib = get_byte_from_cbuf();
                                if (ib != SE) return 1; 
                             }
                             
                             if (send_SB_TTYPE(sockfd)) return 1;
                             break;
                        default:
                          if (send_IAC(sockfd, WONT, ioption)) return 1;
                      } 
                      break;
                    case SE:
                      break;
                    default:           
                      if (send_IAC(sockfd, WONT, ioption)) return 1;                
                 } 
              }
              else return 1;   
              break;
            case LF: 
              if (get_prev_byte_from_cbuf(3)==15) break; 
              new_line();		
              break;
            case CR: 
              cur.x=0; 
              break;
            case BELL: 
              break;
            case BACKSPC:	
              backspace(0);
              break;
	    case 15:		
		break;
	    case 133:
	    case 136:		
		tabstops[cur.x] = 1;
		break;
            case 242: 	      
              break;
            case ESC: 
              if (cbuf_len>=1)
              {
                 ib = get_byte_from_cbuf();    
                 switch(ib) 
                 {
		   case 'D':	
			i = cur.x;
			new_line();
			cur.x = i;
			break;
		   case 'E':	
			new_line();
			break;
		   case 'H':	
			tabstops[cur.x] = 1;
			break;
		   case 'M':	
			if (cur.y == CONSOLE_SHIFT) scroll_screen_down(0);
			else cur.y--;
			break;
		   case 'c':	
			reset_terminal();
			cls(0, CONSOLE_LINES);
			break;
		   case '7':	
			ANSI_saved_cur = cur;
			break;
		   case '8':	
			cur = ANSI_saved_cur;
			break;
                   case '[': 
                        while(cbuf_len)
                        {
                          ib = get_byte_from_cbuf();    

                          if (ib == -1) return 1;
                          if ((ib >= 64) && (ib <= 126))
                          {
                             switch(ib) 
                             {
				case '@':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {			   
					   sscanf(opbuf, "%d", &count);
				     }
				     if (count + cur.x >= CONSOLE_COLUMNS) count = CONSOLE_COLUMNS - cur.x;
				     if (count > 0)
				     {
					for (i=cur.x; i < cur.x + count; i++) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
				     }
				     break;
				case 'A':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {					   
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.y -= count; if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT;
				     break;
				case 'B':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {			   
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.y += count; if (cur.y > CONSOLE_SHIFT+CONSOLE_LINES-1) cur.y = CONSOLE_SHIFT+CONSOLE_LINES-1;
				     break;
				case 'C':	
				     count = 1;	
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {		   
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.x += count; if (cur.x >= CONSOLE_COLUMNS) cur.x = CONSOLE_COLUMNS-1;
				     break;
				case 'D':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {   
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.x -= count; if (cur.x < 0) cur.x = 0;
				     break;
				case 'E':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.x = 0;
				     cur.y += count; if (cur.y >= CONSOLE_LINES + CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT + CONSOLE_LINES - 1;
				     break;
				case 'F':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     cur.x = 0;
				     cur.y -= count; if (cur.y < CONSOLE_SHIFT) cur.y = CONSOLE_SHIFT;
				     break;
				case 'G':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     count--;
				     if ((count >= 0) && (count < CONSOLE_COLUMNS)) cur.x = count;
				     break;
                                case 'H':
                                     if ((get_prev_byte_from_cbuf(3) == ESC) && (get_prev_byte_from_cbuf(2) == '['))
                                     {
                                        cls(0, CONSOLE_LINES); 
                                     }
                                     else
                                     {
					if (extract_params(opbuf, sizeof(opbuf)))
					{
					   sscanf(opbuf, "%d;%d", &cur.y, &cur.x);
					   cur.x--; 
					   cur.y += CONSOLE_SHIFT - 1;
					}
                                     }
                                     break;
				case 'I':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if ((count > 0) && (cur.x+1 < CONSOLE_COLUMNS))
					for (i = cur.x+1; ((i < CONSOLE_COLUMNS) && (count > 0)); i++)
					    if (tabstops[i]) { cur.x = i; count--; }
				     break;
                                case 'J':	

				     count = 0;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if (count == 2) cls(0, CONSOLE_LINES);
				     else if (count == 1) cls_to_cur();	
				     else 
				     {
					tmp_cur = cur;
					
					for (i = cur.x; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
					
					if (cur.y < CONSOLE_LINES-1) cls(cur.y - CONSOLE_SHIFT, CONSOLE_LINES);
					
					cur = tmp_cur;
				     }
                                     break;
				case 'K':	
				     count = 0;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {   
					   sscanf(opbuf, "%d", &count);
				     }

				     if (count == 1)	
				     {
					for (i = 0; i <= cur.x; i++) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
				     }
				     else
				     if (count == 2)	
				     {
					for (i = 0; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
				     }
				     else
				     if (count == 0)	
				     {
					
					for (i = cur.x; i < CONSOLE_COLUMNS; i++) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
				     }
				     break;
				case 'L':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {  
					   sscanf(opbuf, "%d", &count);
				     }
				     while (count--) scroll_screen_down(cur.y - CONSOLE_SHIFT);
				     break;
				case 'M':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if (cur.y - CONSOLE_SHIFT + count > CONSOLE_LINES) count = CONSOLE_LINES - (cur.y - CONSOLE_SHIFT);
				     if (count > 0) cls(cur.y - CONSOLE_SHIFT, count);
				     break;
				case 'P':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if (count > cur.x) count = cur.x;
				     if (count > 0)
				     {
					i = cur.x;
					while ((count--) && (i-- >= 0)) console_textout(i, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
				     }
				     break;
				case 'X':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     { 
					   sscanf(opbuf, "%d", &count);
				     }
				     if (count>0)
				     {
					ib = cur.x;
					while ((count--) && (ib < CONSOLE_COLUMNS)) console_textout(ib++, cur.y, " ", 0, 1, 1);
				     }
				     break;
				case 'Z':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if ((count > 0) && (cur.x > 0))
					for (i = cur.x-1; ((i >= 0) && (count > 0)); i++)
					    if (tabstops[i]) { cur.x = i; count--; }
				     break;
				case 'd':	
				     count = 1;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     count--;
				     if ((count > 0) && (count < CONSOLE_LINES)) cur.y = count + CONSOLE_SHIFT;
				     break;
				case 'f':	
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					sscanf(opbuf, "%d,%d", &cur.y, &cur.x);		
					cur.x--; 
					cur.y += CONSOLE_SHIFT - 1;
				     }
				     break;
				case 'g':
				     count = 0;
				     if (extract_params(opbuf, sizeof(opbuf)))
				     {
					   sscanf(opbuf, "%d", &count);
				     }
				     if (count == 0)	
				     {
					tabstops[cur.x] = 0;
				     }
				     else if (count == 3)	
				     {
					for (i=0; i < CONSOLE_COLUMNS; i++) tabstops[i] = 0;
				     }
				     break;
				case 'm':	
				     break;
				case 'n':	
				     break;
				case 'p':
				     if (get_prev_byte_from_cbuf(2) == '!') reset_terminal();
				     break;
				case 'r':	
				     break;
				case 's':	
				     ANSI_saved_cur = cur;
				     break;
				case 'u':	
				     cur = ANSI_saved_cur;
				     break;
				case '0':
				     break;
                                default:
                                break;
                             } 
                             ib = 0;
                             break; 
                          } 
                        } 
                        break;
                   default:
                        
                        ib = 0;
                        break;
                 } 
              } 
            default:
              if (ib >= 32) console_char((char)ib, 0);
         }
      }
   }
   draw_cursor(1);
   return 0;
}

void monitoring_thread(int *sockfd)
{
   monitoring = 1;
   do
   {
     SDL_Delay(1);
     if (buffer_len > 0) SDL_Delay(10); 
     else 
     if ((buffer_len += recv(*sockfd, buffer+buffer_len, MAXDATASIZE-buffer_len, 0)) == -1)
        stop_monitoring = 1; 
   } while (!stop_monitoring);
   monitoring = 0;
}

int start_thread(int *sockfd)
{
  int timeout;                
  stop_monitoring = 0;
  monitoring = 0;
  if (pthread_create(&ID_thread, NULL , (void *)monitoring_thread, sockfd ) != 0) return 0; 
  timeout=100;
  do SDL_Delay(DELAY_THREAD); while (!monitoring && (--timeout>0));
  if (timeout==0) return 0; 
  return 1; 
}

void stop_thread(int *sockfd)
{
   int timeout = 100;
   char EXIT_CMD[] = {3, 'e','x','i','t',13};

   datasend(sockfd, EXIT_CMD, 6);

   stop_monitoring = 1;
   while (monitoring && (timeout--)) SDL_Delay(DELAY_THREAD); 
   if (timeout <= 0) pthread_cancel(ID_thread); 
}

void change_address()
{
   hide_cursor();
   new_line();
   new_line();
   console_print("Enter address: ");
   draw_cursor(1); 
   entering_adr = 1;
   hostlen = 0;
}

void disconnect(int *sockfd)
{ 
   if (monitoring) stop_thread(sockfd);
   if (*sockfd != -1) close(*sockfd);
}

int reconnect(int *sockfd)
{
   SDL_Rect dstrect;
   struct hostent *he;
   struct sockaddr_in their_addr;	
   Uint32 IPaddr;			
   char IPs[16];
   disconnect(sockfd);
   char *pn = strstr(host, ":");
   if (!pn) pn = strstr(host, " ");
   if (pn)			
   {
      port = atoi(pn+1);	
      *pn = 0;			
   }
   new_line();
   new_line();
   console_print("Connecting to ");
   console_print(host);
   if (port != DEFAULT_PORT) { sprintf(IPs, ":%d", port); console_print(IPs); }
   console_print("...");
   new_line();
   buffer_len = 0; 
   if ((he = gethostbyname(host)) == NULL) return 1; 
   if ((*sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) return 2; 
   their_addr.sin_family = AF_INET;   
   their_addr.sin_port = htons(port);
   their_addr.sin_addr = *((struct in_addr *)he->h_addr);
   memset(&(their_addr.sin_zero), '\0', 8);
   if (connect(*sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) return 3; 
   dstrect.x = 0;
   dstrect.y = 0;
   dstrect.w = 0;
   dstrect.y = 0;
   if (sc_up) SDL_BlitSurface(sc_up, NULL, screen, &dstrect);
   IPaddr = *(Uint32*)he->h_addr_list[0];
   sprintf(IPs, "%d.%d.%d.%d", IPaddr & 0xFF, (IPaddr>>8) & 0xFF, (IPaddr>>16) & 0xFF, (IPaddr>>24) & 0xFF);
   console_textout(78 - strlen(IPs), 1, IPs, 0, 0, 0); 
   strcpy(ttyp, DEF_TTYP); 
   clear_cbuffer();  
   if (!start_thread(sockfd)) return 4;
   return 0; 
}

void error_connect()
{
   new_line();
   new_line();
   console_print("ERROR! Cannot connect to ");
   console_print(host);
   console_print(" !");
   new_line();
   SDL_Delay(2000);
}

int console()
{
   int i, key;
   char ch;
   SDL_Event event;
   char autorepeat = 0;
   char autorepeat_stage = 0;
   int quit = 0;
   int shift, control, caps, special;
   int sockfd = -1;   
  	
  
   memset(console_buffer, ' ', CONSOLE_COLUMNS * CONSOLE_LINES); 
   reset_terminal();
   cursor_visible = 0;
   entering_adr = 0;
   special = 0;   
   strcpy(host, DEFAULT_HOST);
   hostlen = strlen(host);
   port = DEFAULT_PORT;
   console_textout(cur.x, cur.y, " Welcome to SamyConsole 2.1 (c)2010 by geo650", 0, 0, 0);
   // on genoa we can not connect telnet , so we ask for adress...
   int ret = reconnect(&sockfd);
   if (ret)
   {
     	error_connect();
      return ret;
   }

   SDL_EnableUNICODE(1);  
   while (!quit)
   {
     ch = 0;
     SDL_Delay(1);
#ifndef EXE
     remote_key_event_sender(); 
#endif 
      if (buffer_len > 0)
      {
			int buf_len = buffer_len;
         
         if (put_bytes_to_cbuf(buffer, buf_len)) printf("c-buffer overflow error!\n");
         else parse(&sockfd);	
         buffer_len -= buf_len;	
      }

		if (!monitoring) quit = 1; 
		if (SDL_PollEvent(&event))
		{
			kbhits = SDL_GetKeyState(NULL);
			if (kbhits == NULL) quit = 1;
		
			shift = ((kbhits[SDLK_LSHIFT]) || (kbhits[SDLK_RSHIFT]))?1:0;
			control = ((kbhits[SDLK_LCTRL]) || (kbhits[SDLK_RCTRL]))?1:0;
		
			switch (event.type)
			{

				case SDL_KEYDOWN:
					key = event.key.keysym.sym;
					ch = 0;
					if (control) switch (key) {
							case SDLK_c:  
							ch = 3;  
							break;
							case SDLK_z:  
							ch = 26; 
							break;
							default:
							break;
					} else switch (key) 
{
					case SDLK_BACKSPACE:
					ch = BACKSPC; 
					break;
					case SDLK_TAB:
					
					if (cur.x < CONSOLE_COLUMNS)
					{
					for (i = cur.x; i < CONSOLE_COLUMNS; i++)
					if (tabstops[i])
					{
					while (i--) console_textout(cur.x++, cur.y, " ", 0, 1, 1);
					SDL_Flip(screen);
					i = CONSOLE_COLUMNS;
					}
					}
					else ch = ' '; 
					break;
					case SDLK_RETURN:
					case SDLK_KP_ENTER:
					if (entering_adr)
					{
					entering_adr = 0;
					hide_cursor();
					ret = reconnect(&sockfd);
					if (ret)
					{
					error_connect();
					quit=1; 
					}
					ch = 0;
					autorepeat = 0;
					autorepeat_stage = 0;
					}
					else ch = CR;
					break;
					case SDLK_ESCAPE:
					ch = 27;
					break;
					case SDLK_DELETE:
					break;
					case SDLK_SPACE:	ch = ' '; break;
					case SDLK_EXCLAIM:	ch = '!'; break;
					case SDLK_QUOTEDBL:	ch = '"'; break;
					case SDLK_HASH:	ch = '#'; break;
					case SDLK_DOLLAR:	ch = '$'; break;
					case SDLK_AMPERSAND:	ch = '&'; break;
					case SDLK_QUOTE:	ch = shift?'"':'\''; break;
					case SDLK_LEFTPAREN:	ch = '('; break;
					case SDLK_RIGHTPAREN:ch = ')'; break;
					case SDLK_ASTERISK:	ch = '*'; break;
					case SDLK_KP_MULTIPLY: ch = '*'; break;
					case SDLK_PLUS:	
					case SDLK_KP_PLUS:	ch = '+'; break;
					case SDLK_COMMA:	ch = shift?'<':','; break;
					case SDLK_MINUS:	ch = shift?'_':'-'; break;
					case SDLK_KP_MINUS:	ch = '-'; break;
					case SDLK_PERIOD:	ch = shift?'>':'.'; break;
					case SDLK_KP_PERIOD: ch = '.'; break;
					case SDLK_SLASH:	ch = shift?'?':'/'; break;
					case SDLK_KP_DIVIDE: ch = '/'; break;
					case SDLK_COLON:	ch = ':'; break;
					case SDLK_SEMICOLON:	ch = shift?':':';'; break;
					case SDLK_LESS:	ch = '<'; break;
					case SDLK_EQUALS:	ch = shift?'+':'='; break;
					case SDLK_KP_EQUALS:	ch = '='; break;
					case SDLK_GREATER:	ch = '>'; break;
					case SDLK_QUESTION:	ch = '?'; break;
					case SDLK_AT:	ch = '@'; break;
					case SDLK_LEFTBRACKET: ch = shift?'{':'['; break;
					case SDLK_BACKSLASH:	ch = shift?'|':'\\'; break;
					case SDLK_RIGHTBRACKET: ch = shift?'}':']'; break;
					case SDLK_UNDERSCORE:ch = '_'; break;
					case SDLK_BACKQUOTE:	ch = shift?'~':'`'; break;
					case SDLK_POWER: 
					quit = 1;
					break;
					case SDLK_F1:	
					hide_cursor();
					show_help();
					draw_cursor(0);
					ch = CR;
					break;
					case SDLK_F2:	
					change_address();
					break;
					case SDLK_F10:	
					quit = 1;
					break;
					case SDLK_F12:
					hide_cursor();
					cls(0, CONSOLE_LINES);
					draw_cursor(0);
					SDL_Flip(screen); 
					break;
					case SDLK_LEFT:
					special = 1;
					ch = 'D';
					break;
					case SDLK_RIGHT:
					special = 1;
					ch = 'C';
					break;
					case SDLK_UP:
					special = 1;
					ch = 'A';
					break;
					case SDLK_DOWN:
					special = 1;
					ch = 'B';
					break;
					default:
					caps = (event.key.keysym.mod & KMOD_CAPS)?1:0;
					if ((key >= SDLK_KP0) && (key <= SDLK_KP0)) ch = '0' + key - SDLK_KP0;
					else
					if ((key >= SDLK_0) && (key <= SDLK_9))
					{
					ch = '0' + key - SDLK_0;
					if (shift) switch(ch)
					{
					case '0': ch = ')'; break;
					case '1': ch = '!'; break;
					case '2': ch = '@'; break;
					case '3': ch = '#'; break;
					case '4': ch = '$'; break;
					case '5': ch = '%'; break;
					case '6': ch = '^'; break;
					case '7': ch = '&'; break;
					case '8': ch = '*'; break;
					case '9': ch = '('; break;
					}
					}
					else
					if ((key >= SDLK_a) && (key <= SDLK_z)) ch = ((shift^caps)?'A':'a') + key - SDLK_a;
					break;
					}
					break;
				case SDL_KEYUP:
					autorepeat = 0;
					special = 0;
					break;
				case SDL_QUIT:
					quit = 1;
					default:
					break;
			}
			if (ch) { autorepeat = ch; autorepeat_stage = 1; }
		}

     if (special && entering_adr) { special=0; autorepeat=0; }
     
     if (autorepeat)
     {
        int send_now = 0;
        if (autorepeat_stage == 1) { send_now = 1; autorepeat_stage++; } 
	else 
        {
	   if (autorepeat_stage >=6 ) { SDL_Delay(20); send_now = 1; }
           else  { SDL_Delay(100); autorepeat_stage++; }
        }
        if (send_now)
        {
           if (entering_adr)
	   {
	      if (autorepeat == BACKSPC)
	      {
		if ((entering_adr) && (hostlen > 0))
		{
		   hide_cursor();
		   backspace(1);
		   draw_cursor(1);
		   host[--hostlen]=0;
		}
	      }
	      else if (hostlen < MAX_HOSTLEN)
	      {
		 host[hostlen++] = autorepeat; host[hostlen] = 0;		
		 hide_cursor(); console_char(autorepeat, 0); draw_cursor(1);	
	      }
	   }
           else
	   {
	      if (special) { datasend(&sockfd, ESCSEQ, 2); }	
	      datasend(&sockfd, &autorepeat, 1); 
	   }
        }
     }
   } 
 
   stop_thread(&sockfd);
   close(sockfd);
   return 0;
}

#ifndef EXE

int load_usbhid(void)
{
   if (system("insmod ./DRV/usbhid.ko; insmod ./DRV/evdev.ko; i=0; while [ $i -le 31 ]; do mknod /dtv/event$i c 13 $(($i + 64)); i=$(( i + 1 )); done") == -1) return 1;
   return 0;
}

int is_usbhid(void)
{
   FILE *f;
   char cmd[100];
   const char *logfile = "/mtd_ram/hid.log";

   sprintf(cmd, "lsmod | grep usbhid >%s", logfile);
   if (system(cmd) == -1) return 0;	
   f = fopen(logfile, "r");
   if (!f)
   {
      remove(logfile); 
      return 0; 
   }
   if (!fgets(cmd, sizeof(cmd), f)) 
   {
      fclose(f); remove(logfile);
      return 0;
   }
   fclose(f); remove(logfile);
   if (strstr(cmd, "usbhid")) return 1; 
   return 0;
}

int run_telnetd(void)
{
   if (system("mount -t devpts devpts /dev/pts") == -1) return 1;
   if (system("telnetd") == -1) return 1;
   return 0;
}

int is_telnetd(void)
{
   FILE *f;
   char cmd[100];
   const char *logfile = "/mtd_ram/SamyConsole.log";	
							
   sprintf(cmd, "ps|grep telnet[d] >%s", logfile);
   if (system(cmd) == -1) return 0;	
   f = fopen(logfile, "r");
   if (!f)
   {
      remove(logfile); 
      return 0; 
   }
   if (!fgets(cmd, sizeof(cmd), f)) 
   {
      fclose(f); 
      return 0;
   }
   fclose(f); 
   if (strstr(cmd, "telnetd")) return 1; 
   return 0;
}

#endif

#ifndef EXE 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <linux/input.h>
#include <linux/limits.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



extern int InputKeyData, InputKeyState;
static SDLKey keymapKeyboard[KEY_MAX];

// used for patch lib
extern  unsigned current_video;
extern void DUMMY_PumpEvents();
unsigned int *video_struct;
// patch end


#define MAX_EVDEV 32

static struct {
	int fd;
} evdevlist[MAX_EVDEV];

#define NBITS(x) ((((x)-1)/(sizeof(long) * 8))+1)
#define test_bit(nr, addr) \
	 (((1UL << ((nr) % (sizeof(long) * 8))) & ((addr)[(nr) / (sizeof(long) * 8)])) != 0)

static int IsMouseOrKeyboard(int fd) {
	unsigned long evbit[NBITS(EV_MAX)] = { 0 };
	unsigned long relbit[NBITS(REL_MAX)] = { 0 };
	unsigned long keybit[NBITS(KEY_MAX)] = { 0 };

	if ((ioctl(fd, EVIOCGBIT(0, sizeof(evbit)), evbit) < 0) ||
			(ioctl(fd, EVIOCGBIT(EV_REL, sizeof(relbit)), relbit) < 0) ||
			(ioctl(fd, EVIOCGBIT(EV_KEY, sizeof(keybit)), keybit) < 0) ) {
		return 0;
	}
	return 1;
}

static void InitLinuxEventDevices(void) {
        char path[PATH_MAX];
	struct stat sb;
	int duplicate, i, j, n, fd;
	int numdevices;
	dev_t dev_nums[MAX_EVDEV];
	const char *evdev_pattern[] = {
	    "/dev/input/event%d",
	    "/dtv/event%d"
	};

        numdevices = 0;

	for (i = 0; i < MAX_EVDEV; i++) {
		evdevlist[i].fd = -1;
	}

	for (i = 0; i < SDL_arraysize(evdev_pattern); i++) {
		for (j = 0; j < MAX_EVDEV; j++) {
			SDL_snprintf(path, SDL_arraysize(path), evdev_pattern[i], j);
			if (stat(path, &sb) == 0) {
				duplicate = 0;
				for (n = 0; (n < numdevices) && !duplicate; n++) {
                            		if (sb.st_rdev == dev_nums[n]) {
						duplicate = 1;
					}
				}
				if (duplicate) {
					continue;
				}

				fd = open(path, O_RDONLY);
				if (fd < 0) {
					continue;
				}

				if (!IsMouseOrKeyboard(fd)) {
					close(fd);
					continue;
				}
				fcntl(fd, F_SETFL, O_NONBLOCK);
				evdevlist[numdevices].fd = fd;
				dev_nums[numdevices] = sb.st_rdev;
				numdevices++;
			}
		}
	}
}

static SDL_keysym *TranslateEventKey(unsigned short vkey, SDL_keysym *keysym)
{
	keysym->scancode = vkey;
	keysym->sym = keymapKeyboard[vkey];
	keysym->mod = KMOD_NONE;
	keysym->unicode = 0;

	return(keysym);
}

void DUMMY_CloseEventDevices(void) {
	int j;

	for (j = 0; j < MAX_EVDEV; j++) {
		if (evdevlist[j].fd < 0)
			continue;
		close(evdevlist[j].fd);
		evdevlist[j].fd = -1;
	}
}

void process_key_mouse(void) {
	
	SDL_keysym keysym;
	struct input_event ev[64];
	int i, j, len;

	for (i = 0; i < MAX_EVDEV; i++) {
		if (evdevlist[i].fd < 0) {
			continue;
		}
		while ((len = read(evdevlist[i].fd, ev, sizeof(struct input_event))) > 0) {
			len /= sizeof(struct input_event);
			for (j = 0; j < len; j++) {
				if (ev[j].type == EV_KEY) {
					if (ev[j].code == BTN_LEFT) {
						if (ev[j].value == 0)
							SDL_PrivateMouseButton(SDL_RELEASED, SDL_BUTTON_LEFT, 0, 0);
						if (ev[j].value == 1)
							SDL_PrivateMouseButton(SDL_PRESSED, SDL_BUTTON_LEFT, 0, 0);
					} else if (ev[j].code == BTN_MIDDLE) {
						if (ev[j].value == 0)
							SDL_PrivateMouseButton(SDL_RELEASED, SDL_BUTTON_MIDDLE, 0, 0);
						if (ev[j].value == 1)
							SDL_PrivateMouseButton(SDL_PRESSED, SDL_BUTTON_MIDDLE, 0, 0);
					} else if (ev[j].code == BTN_RIGHT) {
						if (ev[j].value == 0)
							SDL_PrivateMouseButton(SDL_RELEASED, SDL_BUTTON_RIGHT, 0, 0);
						if (ev[j].value == 1)
							SDL_PrivateMouseButton(SDL_PRESSED, SDL_BUTTON_RIGHT, 0, 0);
					} else {
						if (ev[j].value == 0) {
							SDL_PrivateKeyboard(SDL_RELEASED, TranslateEventKey(ev[j].code, &keysym));
						}
						if (ev[j].value == 1) {
							SDL_PrivateKeyboard(SDL_PRESSED, TranslateEventKey(ev[j].code, &keysym));
						}
					}
				} else if (ev[j].type == EV_REL) {
					if (ev[j].code == REL_X) {
						SDL_PrivateMouseMotion(0, 1, ev[j].value, 0);
					} else if (ev[j].code == REL_Y) {
						SDL_PrivateMouseMotion(0, 1, 0, ev[j].value);
					} else if (ev[j].code == REL_WHEEL) {
						if (ev[j].value == -1) {
							SDL_PrivateMouseButton(SDL_PRESSED, SDL_BUTTON_WHEELDOWN, 0, 0);
							SDL_PrivateMouseButton(SDL_RELEASED, SDL_BUTTON_WHEELDOWN, 0, 0);
						} else if (ev[j].value == 1) {
							SDL_PrivateMouseButton(SDL_PRESSED, SDL_BUTTON_WHEELUP, 0, 0);
							SDL_PrivateMouseButton(SDL_RELEASED, SDL_BUTTON_WHEELUP, 0, 0);
						}
					}
				}
			}
		}
	}	
}

void DUMMY1_InitOSKeymap(_THIS)
{

	InitLinuxEventDevices();
	memset(keymapKeyboard, 0, sizeof(SDLKey) * KEY_MAX);
	// English ...
	keymapKeyboard[KEY_ESC] = SDLK_ESCAPE;
	keymapKeyboard[KEY_F1] = SDLK_F1;
	keymapKeyboard[KEY_F2] = SDLK_F2;
	keymapKeyboard[KEY_F3] = SDLK_F3;
	keymapKeyboard[KEY_F4] = SDLK_F4;
	keymapKeyboard[KEY_F5] = SDLK_F5;
	keymapKeyboard[KEY_F6] = SDLK_F6;
	keymapKeyboard[KEY_F7] = SDLK_F7;
	keymapKeyboard[KEY_F8] = SDLK_F8;
	keymapKeyboard[KEY_F9] = SDLK_F9;
	keymapKeyboard[KEY_F10] = SDLK_F10;
	keymapKeyboard[KEY_F11] = SDLK_F11;
	keymapKeyboard[KEY_F12] = SDLK_F12;
	keymapKeyboard[KEY_GRAVE] = SDLK_BACKQUOTE;
	keymapKeyboard[KEY_1] = SDLK_1;
	keymapKeyboard[KEY_2] = SDLK_2;
	keymapKeyboard[KEY_3] = SDLK_3;
	keymapKeyboard[KEY_4] = SDLK_4;
	keymapKeyboard[KEY_5] = SDLK_5;
	keymapKeyboard[KEY_6] = SDLK_6;
	keymapKeyboard[KEY_7] = SDLK_7;
	keymapKeyboard[KEY_8] = SDLK_8;
	keymapKeyboard[KEY_9] = SDLK_9;
	keymapKeyboard[KEY_0] = SDLK_0;
	keymapKeyboard[KEY_MINUS] = SDLK_MINUS;
	keymapKeyboard[KEY_EQUAL] = SDLK_EQUALS;
	keymapKeyboard[KEY_BACKSPACE] = SDLK_BACKSPACE;
	keymapKeyboard[KEY_TAB] = SDLK_TAB;
	keymapKeyboard[KEY_Q] = SDLK_q;
	keymapKeyboard[KEY_W] = SDLK_w;
	keymapKeyboard[KEY_E] = SDLK_e;
	keymapKeyboard[KEY_R] = SDLK_r;
	keymapKeyboard[KEY_T] = SDLK_t;
	keymapKeyboard[KEY_Y] = SDLK_y;
	keymapKeyboard[KEY_U] = SDLK_u;
	keymapKeyboard[KEY_I] = SDLK_i;
	keymapKeyboard[KEY_O] = SDLK_o;
	keymapKeyboard[KEY_P] = SDLK_p;
	keymapKeyboard[KEY_LEFTBRACE] = SDLK_LEFTBRACKET;
	keymapKeyboard[KEY_RIGHTBRACE] = SDLK_RIGHTBRACKET;
	keymapKeyboard[KEY_ENTER] = SDLK_RETURN;
	keymapKeyboard[KEY_CAPSLOCK] = SDLK_CAPSLOCK;
	keymapKeyboard[KEY_A] = SDLK_a;
	keymapKeyboard[KEY_S] = SDLK_s;
	keymapKeyboard[KEY_D] = SDLK_d;
	keymapKeyboard[KEY_F] = SDLK_f;
	keymapKeyboard[KEY_G] = SDLK_g;
	keymapKeyboard[KEY_H] = SDLK_h;
	keymapKeyboard[KEY_J] = SDLK_j;
	keymapKeyboard[KEY_K] = SDLK_k;
	keymapKeyboard[KEY_L] = SDLK_l;
	keymapKeyboard[KEY_SEMICOLON] = SDLK_SEMICOLON;
	keymapKeyboard[KEY_APOSTROPHE] = SDLK_QUOTE;
	keymapKeyboard[KEY_BACKSLASH] = SDLK_BACKSLASH;
	keymapKeyboard[KEY_LEFTSHIFT] = SDLK_LSHIFT;
	keymapKeyboard[KEY_Z] = SDLK_z;
	keymapKeyboard[KEY_X] = SDLK_x;
	keymapKeyboard[KEY_C] = SDLK_c;
	keymapKeyboard[KEY_V] = SDLK_v;
	keymapKeyboard[KEY_B] = SDLK_b;
	keymapKeyboard[KEY_N] = SDLK_n;
	keymapKeyboard[KEY_M] = SDLK_m;
	keymapKeyboard[KEY_COMMA] = SDLK_COMMA;
	keymapKeyboard[KEY_DOT] = SDLK_PERIOD;
	keymapKeyboard[KEY_SLASH] = SDLK_SLASH;
	keymapKeyboard[KEY_RIGHTSHIFT] = SDLK_RSHIFT;
	keymapKeyboard[KEY_LEFTCTRL] = SDLK_LCTRL;
	keymapKeyboard[KEY_LEFTALT] = SDLK_LALT;
	keymapKeyboard[KEY_LEFTMETA] = SDLK_LMETA;
	keymapKeyboard[KEY_SPACE] = SDLK_SPACE;
	keymapKeyboard[KEY_RIGHTMETA] = SDLK_RMETA;
	keymapKeyboard[KEY_RIGHTALT] = SDLK_RALT;

	keymapKeyboard[KEY_LEFT] = SDLK_LEFT;
	keymapKeyboard[KEY_UP] = SDLK_UP;
	keymapKeyboard[KEY_DOWN] = SDLK_DOWN;
	keymapKeyboard[KEY_RIGHT] = SDLK_RIGHT;

	keymapKeyboard[KEY_INSERT] = SDLK_INSERT;
	keymapKeyboard[KEY_DELETE] = SDLK_DELETE;
	keymapKeyboard[KEY_HOME] = SDLK_HOME;
	keymapKeyboard[KEY_END] = SDLK_END;
	keymapKeyboard[KEY_PAGEUP] = SDLK_PAGEUP;
	keymapKeyboard[KEY_PAGEDOWN] = SDLK_PAGEDOWN;

	keymapKeyboard[KEY_SYSRQ] = SDLK_SYSREQ;
	keymapKeyboard[KEY_SCROLLLOCK] = SDLK_SCROLLOCK;
	keymapKeyboard[KEY_PAUSE] = SDLK_PAUSE;

	keymapKeyboard[KEY_NUMLOCK] = SDLK_NUMLOCK;
	keymapKeyboard[KEY_KPSLASH] = SDLK_KP_DIVIDE;
	keymapKeyboard[KEY_KPASTERISK] = SDLK_PAUSE;
	keymapKeyboard[KEY_KPMINUS] = SDLK_KP_MINUS;
	keymapKeyboard[KEY_KPPLUS] = SDLK_KP_PLUS;
	keymapKeyboard[KEY_KPENTER] = SDLK_KP_ENTER;
	keymapKeyboard[KEY_KPDOT] = SDLK_KP_PERIOD;
	keymapKeyboard[KEY_KP0] = SDLK_KP0;
	keymapKeyboard[KEY_KP1] = SDLK_KP1;
	keymapKeyboard[KEY_KP2] = SDLK_KP2;
	keymapKeyboard[KEY_KP3] = SDLK_KP3;
	keymapKeyboard[KEY_KP4] = SDLK_KP4;
	keymapKeyboard[KEY_KP5] = SDLK_KP5;
	keymapKeyboard[KEY_KP6] = SDLK_KP6;
	keymapKeyboard[KEY_KP7] = SDLK_KP7;
	keymapKeyboard[KEY_KP8] = SDLK_KP8;
	keymapKeyboard[KEY_KP9] = SDLK_KP9;
	
}

static SDL_keysym *TranslateKey1( unsigned short vkey, SDL_keysym *keysym )
{
	/* Set the keysym information */
	keysym->scancode = vkey;
	keysym->sym = keymapKeyboard[ vkey ];
	keysym->mod = KMOD_NONE;
	keysym->unicode = 0;
		
	return(keysym);
}

void MY_PumpEvents(_THIS)
{

	SDL_keysym keysym;

	if( InputKeyState == 1 ) {
		mcas_debug( "[SDL - %s] KEY_PRESSED vvvvvvv \n\n", __FUNCTION__ );	
		SDL_PrivateKeyboard( SDL_PRESSED, TranslateKey1( InputKeyData, &keysym ) );

#ifdef STI_Ready
		//InputKeyState = 2;
		SDL_PrivateKeyboard( SDL_RELEASED, TranslateKey1( InputKeyData, &keysym ) );
#endif

	}	
	if( InputKeyState == 2 ) {
		mcas_debug( "[SDL - %s]  KEY_RELEASED ~~~~~ \n\n", __FUNCTION__); 
		SDL_PrivateKeyboard( SDL_RELEASED, TranslateKey1( InputKeyData, &keysym ) );
	}
								
	InputKeyState = 0;
	process_key_mouse();

}
#endif
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Game_Main(const char *path, const char *udn __attribute__ ((unused)))
{
   int err;
   char s[256];
   char old_path[256];
   screen = NULL;
   unsigned char *retval ;
   unsigned int i, a , c = 80, d = c + 10, e = d + 10;
   char dd[1024];

	#if 0
	#if defined  (LIN_SIM)
	
	#else 
	
		#ifndef EXE
		   if (!is_telnetd())
		   {
		      if (run_telnetd()) return 1;
		      if (!is_telnetd()) return 1;
		   }
		  
		   if (!is_usbhid())
		   {
		      if (load_usbhid()) return 1;
		      if (!is_usbhid()) return 1;
		   }
		#endif
	
	#endif
 	#endif

   fontrect.h = CHARHEIGHT;
   fontrect.w = CHARWIDTH;
 	#ifndef EXE 
 	DUMMY1_InitOSKeymap();
   #endif
   if (SDL_Init(SDL_INIT_VIDEO  ) < 0) {
   	 mcas_debug("Game_Main SDL_Init return\n");
   	 return 1;
 	}

   screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, 0);
   mcas_debug("Game_Main screen %x\n", screen);
	// Denny Patch libSDL.so END 
	#ifndef EXE 
	video_struct = current_video;
	#if 1
	for (i = 0; i < 100; i++) {
		if ( video_struct[i] == (int) DUMMY_PumpEvents ) {
				video_struct[i] = (int) MY_PumpEvents;
				mcas_debug("curr video  %d  @ %x  replaced\n", i,  video_struct[i] );
				break;
		}
	}
	#endif
	#endif
	// Patch libSDL.so END
   if (screen)
   {
		#ifndef EXE
      SDL_ShowCursor(SDL_DISABLE);
		#endif
	   SDL_FillRect( screen , &screen->clip_rect ,  SDL_MapRGB( screen->format , 0, 0, 0 ) );
	   videoinfo = (SDL_VideoInfo *)SDL_GetVideoInfo();
	   cursor_color = SDL_MapRGB(videoinfo->vfmt, 255,255,255);
	   screen_color = SDL_MapRGB(videoinfo->vfmt, 0,0,0);
	   margin_color = SDL_MapRGB(videoinfo->vfmt, 0,0,64);
	   sprintf(s, "%s/%s", path, FONTBITMAP);
	   fonts = IMG_Load(s);
	   sprintf(s, "%s/%s", path, SC_UPBITMAP);
	   sc_up = IMG_Load(s);
	   sprintf(s, "%s/%s", path, SC_DOWNBITMAP);
	   sc_down = IMG_Load(s);
	   dstrect.x = 0;
	   dstrect.y = 0;
	   dstrect.w = 0;
	   dstrect.y = 0;
	   if (sc_up) SDL_BlitSurface(sc_up, NULL, screen, &dstrect);
	   dstrect.y = SCREEN_HEIGHT - 70;
	   if (sc_down) SDL_BlitSurface(sc_down, NULL, screen, &dstrect);
	   if (fonts != NULL)
	   {
	      err = console();
	      if (err)
	      {
	         switch(err)
	         {
	           case 1: console_textout(1, 27, " ERROR: Cannot get host info! URL cannot be resolved! ", 1, 0, 0); break;
	           case 2: console_textout(1, 27, " ERROR: Cannot create socket! ", 1, 0, 0); break;
	           case 3: console_textout(1, 27, " ERROR: Cannot connect! ", 1, 0, 0); break;
	           default: break;
	         }
	         SDL_Delay(10);
	      }
	      console_textout(1, 28, " Exiting... ", 1, 0, 0);
	      SDL_Delay(10);
	      SDL_FreeSurface(fonts);
	   }
	   SDL_FreeSurface(sc_up);
	   SDL_FreeSurface(sc_down);
   }
	#ifndef EXE 
	DUMMY_CloseEventDevices();
	#endif
   SDL_Quit();
   return 0;
}

#ifdef EXE

int main (int argc, char *argv[])
{
   char cur_path[256];
   if (getcwd(cur_path, sizeof(cur_path)) == NULL) strcpy(cur_path, "/");
   Game_Main(cur_path, "");
   return 0;
}

#endif


